# std::basic_filebuf< _CharT, _Traits > Class Template Reference

The actual work of input and output (for files). More...

Inheritance diagram for std::basic_filebuf< _CharT, _Traits >:

[legend]
Collaboration diagram for std::basic_filebuf< _CharT, _Traits >:

[legend]
List of all members.

## Public Types

typedef _CharT | char_type
typedef _Traits | traits_type
typedef traits_type::int_type | int_type
typedef traits_type::pos_type | pos_type
typedef traits_type::off_type | off_type

## Public Member Functions

| basic_filebuf ()
| Does not open any files.
virtual | ~basic_filebuf ()
| The destructor closes the file first.
bool | is_open () const throw ()
| Returns true if the external file is open.
__filebuf_type * | open (const char *__s, ios_base::openmode __mode)
| Opens an external file.
__filebuf_type * | close () throw ()
| Closes the currently associated file.
locale | pubimbue (const locale &__loc)
| Entry point for imbue().
locale | getloc () const
| Locale access.
streamsize | in_avail ()
| Looking ahead into the stream.
int_type | snextc ()
| Getting the next character.
int_type | sbumpc ()
| Getting the next character.
int_type | sgetc ()
| Getting the next character.
streamsize | sgetn (char_type *__s, streamsize __n)
| Entry point for xsgetn.
int_type | sputbackc (char_type __c)
| Pushing characters back into the input stream.
int_type | sungetc ()
| Moving backwards in the input stream.
int_type | sputc (char_type __c)
| Entry point for all single-character output functions.
streamsize | sputn (const char_type *__s, streamsize __n)
| Entry point for all single-character output functions.
void | stossc ()
| Tosses a character.
__streambuf_type * | pubsetbuf (char_type *__s, streamsize __n)
| Entry points for derived buffer functions.
pos_type | pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Entry points for derived buffer functions.
pos_type | pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Entry points for derived buffer functions.
int | pubsync ()
| Entry points for derived buffer functions.

## Protected Member Functions

virtual streamsize | showmanyc ()
| Investigating the data available.
virtual int_type | underflow ()
| Fetches more data from the controlled sequence.
virtual int_type | uflow ()
| Fetches more data from the controlled sequence.
virtual int_type | pbackfail (int_type __c=_Traits::eof())
| Tries to back up the input sequence.
virtual int_type | overflow (int_type __c=_Traits::eof())
| Consumes data from the buffer; writes to the controlled sequence.
virtual __streambuf_type * | setbuf (char_type *__s, streamsize __n)
| Manipulates the buffer.
virtual pos_type | seekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Alters the stream positions.
virtual pos_type | seekpos (pos_type __pos, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Alters the stream positions.
virtual int | sync ()
| Synchronizes the buffer arrays with the controlled sequences.
virtual void | imbue (const locale &__loc)
| Changes translations.
virtual streamsize | xsgetn (char_type *__s, streamsize __n)
| Multiple character extraction.
virtual streamsize | xsputn (const char_type *__s, streamsize __n)
| Multiple character insertion.
void | gbump (int __n)
| Moving the read position.
void | setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
| Setting the three read area pointers.
void | pbump (int __n)
| Moving the write position.
void | setp (char_type *__pbeg, char_type *__pend)
| Setting the three write area pointers.
char_type * | eback () const
| Access to the get area.
char_type * | gptr () const
| Access to the get area.
char_type * | egptr () const
| Access to the get area.
char_type * | pbase () const
| Access to the put area.
char_type * | pptr () const
| Access to the put area.
char_type * | epptr () const
| Access to the put area.

## Detailed Description

### template<typename _CharT, typename _Traits>
class std::basic_filebuf< _CharT, _Traits >

The actual work of input and output (for files).

This class associates both its input and output sequence with an external disk file, and maintains a joint file position for both sequences. Many of its sematics are described in terms of similar behavior in the Standard C Library's `FILE` streams.

Definition at line 63 of file fstream.

## Member Typedef Documentation

template<typename _CharT, typename _Traits>
typedef _CharT std::basic_filebuf< _CharT, _Traits >::char_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Reimplemented in __gnu_cxx::stdio_filebuf< _CharT, _Traits >.

Definition at line 67 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::pbackfail().

template<typename _CharT, typename _Traits>
typedef traits_type::int_type std::basic_filebuf< _CharT, _Traits >::int_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Reimplemented in __gnu_cxx::stdio_filebuf< _CharT, _Traits >.

Definition at line 69 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), and std::basic_filebuf< _CharT, _Traits >::pbackfail().

template<typename _CharT, typename _Traits>
typedef traits_type::off_type std::basic_filebuf< _CharT, _Traits >::off_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Reimplemented in __gnu_cxx::stdio_filebuf< _CharT, _Traits >.

Definition at line 71 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::seekoff(), and std::basic_filebuf< _CharT, _Traits >::seekpos().

template<typename _CharT, typename _Traits>
typedef traits_type::pos_type std::basic_filebuf< _CharT, _Traits >::pos_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_streambuf< _CharT, _Traits >. Reimplemented in __gnu_cxx::stdio_filebuf< _CharT, _Traits >. Definition at line 70 of file fstream. Referenced by std::basic_filebuf< _CharT, _Traits >::seekoff().

template<typename _CharT, typename _Traits>
typedef _Traits std::basic_filebuf< _CharT, _Traits >::traits_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_streambuf< _CharT, _Traits >. Reimplemented in __gnu_cxx::stdio_filebuf< _CharT, _Traits >. Definition at line 68 of file fstream.

## Constructor & Destructor Documentation

template<typename _CharT, typename _Traits>
std::basic_filebuf< _CharT, _Traits >::basic_filebuf | ( |  | ) |

| Does not open any files. The default constructor initializes the parent class using its own default ctor. Definition at line 75 of file fstream.tcc.

template<typename _CharT, typename _Traits>
virtual std::basic_filebuf< _CharT, _Traits >::~basic_filebuf | ( |  | ) | `[inline, virtual]`

| The destructor closes the file first. Definition at line 156 of file fstream.

## Member Function Documentation

template<typename _CharT, typename _Traits>
basic_filebuf< _CharT, _Traits >::__filebuf_type * std::basic_filebuf< _CharT, _Traits >::close | ( |  | ) | throw ()

Closes the currently associated file.

Returns:
  `this` on success, NULL on failure

If no file is currently open, this function immediately fails.

If a "put buffer area" exists, `overflow(eof)` is called to flush all the characters. The file is then closed.

If any operations fail, this function also fails.

Definition at line 121 of file fstream.tcc.

Referenced by std::basic_filebuf< _CharT, _Traits >::open().

template<typename _CharT, typename _Traits>
char_type* std::basic_streambuf< _CharT, _Traits >::eback | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 598 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos().

template<typename _CharT, typename _Traits>
char_type* std::basic_streambuf< _CharT, _Traits >::egptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 604 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::in_avail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos().

template<typename _CharT, typename _Traits>
char_type* std::basic_streambuf< _CharT, _Traits >::epptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 653 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

template<typename _CharT, typename _Traits>
void std::basic_streambuf< _CharT, _Traits >::gbump | ( | int | __n | ) | `[inline, protected, inherited]`

Moving the read position.

Parameters:

  n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 614 of file streambuf.

template<typename _CharT, typename _Traits>
locale std::basic_streambuf< _CharT, _Traits >::getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 394 of file streambuf.

template<typename _CharT, typename _Traits>
char_type* std::basic_streambuf< _CharT, _Traits >::gptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 601 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_streambuf< char, char_traits< char > >::in_avail(), std::basic_streambuf< _CharT, _Traits >::sbumpc(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

template<typename _CharT, typename _Traits>
void std::basic_filebuf< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) | `[protected, virtual]`

Changes translations.

Parameters:

  loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, "Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained." This function simply stores the new locale for use by derived classes.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 511 of file fstream.tcc.

References std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::gptr(), std::basic_streambuf< _CharT, _Traits >::pbase(), and std::basic_streambuf< _CharT, _Traits >::pptr().

template<typename _CharT, typename _Traits>
streamsize std::basic_streambuf< _CharT, _Traits >::in_avail | ( |  | ) | `[inline, inherited]`

Looking ahead into the stream.

Returns:
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 434 of file streambuf.

template<typename _CharT, typename _Traits>
bool std::basic_filebuf< _CharT, _Traits >::is_open | ( |  | ) | const throw ()`[inline]`

| Returns true if the external file is open. Definition at line 167 of file fstream. Referenced by std::basic_filebuf< _CharT, _Traits >::open(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_filebuf< _CharT, _Traits >::setbuf(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), and __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf().

template<typename _CharT, typename _Traits>
basic_filebuf< _CharT, _Traits >::__filebuf_type * std::basic_filebuf< _CharT, _Traits >::open | ( | const char * | __s,
|  | ios_base::openmode | __mode
| ) |

Opens an external file.

Parameters:

  s | The name of the file.
  mode | The open mode flags.

Returns:
  `this` on success, NULL on failure

If a file is already open, this function immediately fails. Otherwise it tries to open the file named s using the flags given in mode.

[Table 92 gives the relation between openmode combinations and the equivalent fopen() flags, but the table has not been copied yet.]

Definition at line 83 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::close(), std::basic_filebuf< _CharT, _Traits >::is_open(), std::basic_filebuf< _CharT, _Traits >::seekoff(), and std::basic_filebuf< _CharT, _Traits >::underflow().

template<typename _CharT, typename _Traits>
basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::overflow | ( | int_type | __c = _Traits::eof() | ) | `[protected, virtual]`

Consumes data from the buffer; writes to the controlled sequence.

Parameters:

  c | An additional character to consume.

Returns:
  eof() to indicate failure, something else (usually c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is "consumed", with "some effect" on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if c is not `eof()`.

For a formal definiton of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 255 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::int_type.

template<typename _CharT, typename _Traits>
basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::pbackfail | ( | int_type | __c = _Traits::eof() | ) | `[protected, virtual]`

Tries to back up the input sequence.

Parameters:

  c | The character to be inserted back into the sequence.

Returns:
  eof() on failure, "some other value" on success

Postcondition:
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 182 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::char_type, std::basic_filebuf< _CharT, _Traits >::int_type, std::basic_filebuf< _CharT, _Traits >::seekoff(), and std::basic_filebuf< _CharT, _Traits >::underflow().

template<typename _CharT, typename _Traits>
char_type* std::basic_streambuf< _CharT, _Traits >::pbase | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 647 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos().

template<typename _CharT, typename _Traits>
void std::basic_streambuf< _CharT, _Traits >::pbump | ( | int | __n | ) | `[inline, protected, inherited]`

Moving the write position.

Parameters:

  n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 663 of file streambuf.

template<typename _CharT, typename _Traits>
char_type* std::basic_streambuf< _CharT, _Traits >::pptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 650 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

template<typename _CharT, typename _Traits>
locale std::basic_streambuf< _CharT, _Traits >::pubimbue | ( | const locale & | __loc | ) | `[inline, inherited]`

Entry point for imbue().

Parameters:

  loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 378 of file streambuf.

template<typename _CharT, typename _Traits>
pos_type std::basic_streambuf< _CharT, _Traits >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out
| ) | `[inline, inherited]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 411 of file streambuf.

template<typename _CharT, typename _Traits>
pos_type std::basic_streambuf< _CharT, _Traits >::pubseekpos | ( | pos_type | __sp,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out
| ) | `[inline, inherited]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 416 of file streambuf.

template<typename _CharT, typename _Traits>
__streambuf_type* std::basic_streambuf< _CharT, _Traits >::pubsetbuf | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inline, inherited]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 407 of file streambuf.

template<typename _CharT, typename _Traits>
int std::basic_streambuf< _CharT, _Traits >::pubsync | ( |  | ) | `[inline, inherited]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 421 of file streambuf.

template<typename _CharT, typename _Traits>
basic_streambuf< _CharT, _Traits >::int_type std::basic_streambuf< _CharT, _Traits >::sbumpc | ( |  | ) | `[inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 49 of file streambuf.tcc.

References std::basic_streambuf< _CharT, _Traits >::char_type, std::basic_streambuf< _CharT, _Traits >::gptr(), std::basic_streambuf< _CharT, _Traits >::int_type, and std::basic_streambuf< _CharT, _Traits >::uflow().

Referenced by std::operator>>().

template<typename _CharT, typename _Traits>
basic_filebuf< _CharT, _Traits >::pos_type std::basic_filebuf< _CharT, _Traits >::seekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out
| ) | `[protected, virtual]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 432 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::is_open(), std::max(), std::basic_filebuf< _CharT, _Traits >::off_type, std::basic_filebuf< _CharT, _Traits >::pos_type, and std::basic_filebuf< _CharT, _Traits >::sync().

Referenced by std::basic_filebuf< _CharT, _Traits >::open(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), and std::basic_filebuf< _CharT, _Traits >::seekpos().

template<typename _CharT, typename _Traits>
basic_filebuf< _CharT, _Traits >::pos_type std::basic_filebuf< _CharT, _Traits >::seekpos | ( | pos_type | __pos,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out
| ) | `[protected, virtual]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 494 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::off_type, and std::basic_filebuf< _CharT, _Traits >::seekoff().

template<typename _CharT, typename _Traits>
basic_filebuf< _CharT, _Traits >::__streambuf_type * std::basic_filebuf< _CharT, _Traits >::setbuf | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[protected, virtual]`

Manipulates the buffer.

Parameters:

  s | Pointer to a buffer area.
  n | Size of s.

Returns:
  `this`

If no file has been opened, and both s and n are zero, then the stream becomes unbuffered. Otherwise, `s` is used as a buffer; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#2 for more.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 407 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::is_open().

template<typename _CharT, typename _Traits>
void std::basic_streambuf< _CharT, _Traits >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend
| ) | `[inline, protected, inherited]`

Setting the three read area pointers.

Parameters:

  gbeg | A pointer.
  gnext | A pointer.
  gend | A pointer.

Postcondition:
  gbeg == `eback()`, gnext == `gptr()`, and gend == `egptr()`

Definition at line 625 of file streambuf.

template<typename _CharT, typename _Traits>
void std::basic_streambuf< _CharT, _Traits >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend
| ) | `[inline, protected, inherited]`

Setting the three write area pointers.

Parameters:

  pbeg | A pointer.
  pend | A pointer.

Postcondition:
  pbeg == `pbase()`, pbeg == `pptr()`, and pend == `epptr()`

Definition at line 673 of file streambuf.

template<typename _CharT, typename _Traits>
int_type std::basic_streambuf< _CharT, _Traits >::sgetc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 488 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::snextc().

template<typename _CharT, typename _Traits>
streamsize std::basic_streambuf< _CharT, _Traits >::sgetn | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inline, inherited]`

Entry point for xsgetn.

Parameters:

  s | A buffer area.
  n | A count.

Returns xsgetn(s,n). The effect is to fill s[0] through s[n-1] with characters from the input sequence, if possible.

Definition at line 507 of file streambuf.

template<typename _CharT, typename _Traits>
streamsize std::basic_filebuf< _CharT, _Traits >::showmanyc | ( |  | ) | `[protected, virtual]`

Investigating the data available.

Returns:
  An estimate of the number of characters available in the input sequence, or -1.

"If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail." [27.5.2.4.3]/1

Note:
  Base class version does nothing, returns zero.

  The standard adds that "the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return "immediately".

  The standard adds that "the morphemes of `showmanyc` are "es-how-many-see", not "show-manic".

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 168 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::is_open().

template<typename _CharT, typename _Traits>
int_type std::basic_streambuf< _CharT, _Traits >::snextc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 461 of file streambuf.

template<typename _CharT, typename _Traits>
basic_streambuf< _CharT, _Traits >::int_type std::basic_streambuf< _CharT, _Traits >::sputbackc | ( | char_type | __c | ) | `[inherited]`

Pushing characters back into the input stream.

Parameters:

  c | The character to push back.

Returns:
  The previous character, if possible.

Similar to sungetc(), but c is pushed onto the stream instead of "the previous character". If successful, the next character fetched from the input stream will be c.

Definition at line 66 of file streambuf.tcc.

References std::basic_streambuf< _CharT, _Traits >::int_type, and std::basic_streambuf< _CharT, _Traits >::pbackfail().

Referenced by std::operator>>().

template<typename _CharT, typename _Traits>
basic_streambuf< _CharT, _Traits >::int_type std::basic_streambuf< _CharT, _Traits >::sputc | ( | char_type | __c | ) | `[inherited]`

Entry point for all single-character output functions.

Parameters:

  c | A character to output.

Returns:
  c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores c in that position, increments the position, and returns `traits::to_int_type(c)`. If a write position is not available, returns `overflow(c)`.

Definition at line 104 of file streambuf.tcc.

References std::basic_streambuf< _CharT, _Traits >::int_type, and std::basic_streambuf< _CharT, _Traits >::overflow().

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow().

template<typename _CharT, typename _Traits>
streamsize std::basic_streambuf< _CharT, _Traits >::sputn | ( | const char_type * | __s,
|  | streamsize | __n
| ) | `[inline, inherited]`

Entry point for all single-character output functions.

Parameters:

  s | A buffer read area.
  n | A count.

One of two public output functions.

Returns xsputn(s,n). The effect is to write s[0] through s[n-1] to the output sequence, if possible.

Definition at line 563 of file streambuf.

template<typename _CharT, typename _Traits>
void std::basic_streambuf< _CharT, _Traits >::stossc | ( |  | ) | `[inline, inherited]`

Tosses a character.

Advances the read pointer, ignoring the character that would have been read.

See http://gcc.gnu.org/ml/libstdc++/2002-05/msg00168.html

Note:
  This function has been deprecated by the standard. You must define `_GLIBCPP_DEPRECATED` to make this visible; see c++config.h.

Definition at line 910 of file streambuf.

template<typename _CharT, typename _Traits>
basic_streambuf< _CharT, _Traits >::int_type std::basic_streambuf< _CharT, _Traits >::sungetc | ( |  | ) | `[inherited]`

Moving backwards in the input stream.

Returns:
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to "unget" the last character "gotten".

Definition at line 83 of file streambuf.tcc.

References std::basic_streambuf< _CharT, _Traits >::int_type, and std::basic_streambuf< _CharT, _Traits >::pbackfail().

template<typename _CharT, typename _Traits>
virtual int std::basic_filebuf< _CharT, _Traits >::sync | ( |  | ) | `[inline, protected, virtual]`

Synchronizes the buffer arrays with the controlled sequences.

Returns:
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of "failure".

Note:
  Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 322 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::seekoff().

template<typename _CharT, typename _Traits>
basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::uflow | ( |  | ) | `[protected, virtual]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 458 of file fstream.

template<typename _CharT, typename _Traits>
basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::underflow | ( |  | ) | `[protected, virtual]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is "refilled". In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definiton of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#6

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 453 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::open(), and std::basic_filebuf< _CharT, _Traits >::pbackfail().

template<typename _CharT, typename _Traits>
virtual streamsize std::basic_filebuf< _CharT, _Traits >::xsgetn | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inline, protected, virtual]`

Multiple character extraction.

Parameters:

  s | A buffer area.
  n | Maximum number of characters to assign.

Returns:
  The number of characters assigned.

Fills s[0] through s[n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 354 of file fstream.

template<typename _CharT, typename _Traits>
virtual streamsize std::basic_filebuf< _CharT, _Traits >::xsputn | ( | const char_type * | __s,
|  | streamsize | __n
| ) | `[inline, protected, virtual]`

Multiple character insertion.

Parameters:

  s | A buffer area.
  n | Maximum number of characters to write.

Returns:
  The number of characters written.

Writes s[0] through s[n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 376 of file fstream.

The documentation for this class was generated from the following files:

- fstream
- fstream.cc
- fstream.tcc